import { className, mergeData, renderRule } from '../../core/utils'
import Space from '../space/space'
import rules from './table-cell.rules'

export default {
  functional: true,
  inject: [
    'fela',
    'croudClassName'
  ],
  props: {
    tag: {
      type: String
    },
    dim: {
      type: Boolean,
      default: false
    },
    space: {
      type: [ Array, String ]
    },
    layout: {
      type: [ Boolean, Object ],
      default: false
    },
    flex: {
      type: [ Boolean, Object ],
      default: false
    }
  },
  render(h, ctx) {
    const { space, tag } = ctx.props
    const classes = renderRule(ctx, rules.cell)
    return h(Space, mergeData(ctx, {
      class: className(ctx, 'table-cell', classes),
      props: { tag, edges: space }
    }), ctx.children)
  }
}
