import VueFela from 'vue-fela'
import { createRenderer as createFelaRenderer } from 'fela'
import { createRenderer as createVueRenderer } from 'vue-server-renderer'
import { createLocalVue, shallow } from '@vue/test-utils'
import VueCroud, { createConfig } from './index'

export const VueRenderer = createVueRenderer()

export const setupLocalVue = () => {
  const config = createConfig()
  const renderer = createFelaRenderer(config)
  const localVue = createLocalVue()
  localVue.use(VueFela, { renderer })
  localVue.use(VueCroud)
  return localVue
}

export const wrapComponent = (component, options) => {
  const localVue = setupLocalVue()
  return shallow(component, Object.assign({
    localVue,
    stubs: [
      'router-link',
      'router-view'
    ]
  }, options))
}

export const testSnapshot = (wrapper) => {
  VueRenderer.renderToString(wrapper.vm, (err, str) => {
    expect(str).toMatchSnapshot()
    expect(err).toBeNull()
  })
}
